Bug 1679970 - Review Request: cranc - Pagure CLI tool
Summary: Review Request: cranc - Pagure CLI tool
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Robert-André Mauchin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-02-22 11:42 UTC by LenkaSeg
Modified: 2019-12-12 09:37 UTC (History)
5 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
zebob.m: fedora-review+


Attachments (Terms of Use)

Description LenkaSeg 2019-02-22 11:42:18 UTC
Spec URL: https://pagure.io/python-cranc/raw/f29/f/python-cranc.spec
SRPM URL: http://releases.pagure.org/python-cranc/python-cranc-0.2.2-1.fc29.src.rpm
Description: Pagure CLI tool, which uses libpagure and click
Fedora Account System Username: lenkaseg

This is my first package, and I'm seeking a sponsor.

Comment 1 Robert-André Mauchin 2019-02-23 15:28:08 UTC
 - You specify a conditional for Python 3 but don't use it? You must restrict Python 2 packages to RHEL < 8 as Fedora and RHEL 8 only accept Python 3 packages.

 - /usr/bin/ → %{_bindir}

 - %{python2_sitelib}/*  / %{python3_sitelib}/* is forbidden, please be more specific instead.

 - Your %changedlog entry has the wrong Version-Release info

Comment 2 LenkaSeg 2019-02-25 14:37:51 UTC
Thank you for the review!

I incorporated the changes:

Spec URL: https://pagure.io/python-cranc/blob/f29/f/python-cranc.spec
SRPM URL: http://releases.pagure.org/python-cranc/python-cranc-0.2.2-2.fc29.src.rpm

Comment 3 Robert-André Mauchin 2019-02-25 16:11:14 UTC
 - The bug name and SPEC name must be the same, python-cranc. Maybe you can Provides: cranc

 - Nitpick: Buildrequires: → BuildRequires:

 - Escape the macros in %changelog and use linebreaks:

* Mon Feb 25 2019 Lenka Segura <lenka@sepu.cz> - 0.2.2-2
- Python2 removed
- %%{_bindir} used
- cranc specified for %%{python3_sitelib}
- version-release info corrected in changelog


 - Fix the URL

URL:            https://pagure.io/cranc



Package approved.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL (v3 or later)", "Unknown or generated". 10 files have
     unknown license. Detailed output of licensecheck in
     /home/bob/packaging/review/python-cranc/review-python-
     cranc/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python3-cranc-0.2.2-2.fc31.noarch.rpm
          python-cranc-0.2.2-2.fc31.src.rpm
python3-cranc.noarch: W: invalid-url URL https\://pagure.io/cranc
python3-cranc.noarch: W: no-manual-page-for-binary cranc
python-cranc.src: W: spelling-error Summary(en_US) Pagure -> Prague, Pasture
python-cranc.src: W: invalid-url URL https\://pagure.io/cranc
python-cranc.src:54: W: macro-in-%changelog %{_bindir}
python-cranc.src:54: W: macro-in-%changelog %{python3_sitelib}
2 packages and 0 specfiles checked; 0 errors, 6 warnings.

Comment 4 Carl George 2019-02-25 17:10:18 UTC
Since the primary purpose of this software is a cli appliction, not a Python library, I suggest renaming it to just cranc.

-Name:           python-cranc
+Name:           cranc

-%package     -n python%{python3_pkgversion}-cranc
-Summary:     CLI tool to interact with Pagure

-%description -n python%{python3_pkgversion}-cranc
-Cranc is a Pagure command line interface tool using Libpagure and Click.

-%autosetup -n cranc-%{version}
+%autosetup

-%files -n python%{python3_pkgversion}-cranc
+%files

And of course rename the spec file to cranc.spec.  Also there is a typo in the URL:

-URL:            https\://pagure.io/cranc
+URL:            https://pagure.io/cranc

Comment 5 LenkaSeg 2019-02-26 11:14:35 UTC
Thanks for the nice reviews!
I made all the suggested changes (I hope I understood them all) 
and hopefully didn't create any more typos.

I didn't know about rpmlint, very useful!

Spec URL: https://pagure.io/python-cranc/blob/f29/f/python-cranc.spec
SRPM URL: http://releases.pagure.org/python-cranc/cranc-0.2.2-3.fc29.src.rpm

Comment 6 LenkaSeg 2019-02-26 11:18:59 UTC
Correction: Spec URL: https://pagure.io/python-cranc/blob/f29/f/cranc.spec

Comment 7 Carl George 2019-02-26 15:27:45 UTC
Looks good, the only thing lacking is what Robert pointed out about empty lines between the changelog entries.


* Tue Feb 26 2019 Lenka Segura <lenka@sepu.cz> - 0.2.2-3
- python-cranc renamed to cranc 
- typos fixed (BuildRequires 
- changelog fixed

* Mon Feb 25 2019 Lenka Segura <lenka@sepu.cz> - 0.2.2-2
- Python2 removed
- %%{_bindir} used
- cranc specified for %%{python3_sitelib}
- version-release info corrected in changelog

* Tue Feb 19 2019 Lenka Segura <lenka@sepu.cz> - 0.2.2
- Update to 0.2.2


That's a fairly minor thing that you can fix on import.  Robert already approved the package, so you're clear to go ahead and request the distgit repo (fedpkg request-repo ...).

Comment 8 LenkaSeg 2019-02-27 15:22:00 UTC
I requested the repo (fedpkg request-repo ...) and got this answer:

The Bugzilla bug's review is approved by a user that is not a packager

Comment 9 Carl George 2019-02-27 15:25:52 UTC
Sorry about that, I missed the fact that you need a sponsor.

https://fedoraproject.org/wiki/How_to_get_sponsored_into_the_packager_group

Comment 10 LenkaSeg 2019-02-27 15:33:59 UTC
Ah, sponsor. That's a challenge...

Comment 11 Gwyn Ciesla 2019-02-28 15:53:36 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/cranc

Comment 12 Thomas Moschny 2019-12-12 09:37:32 UTC
Can we close this bug? Packages have landed (but see bug 1782746).


Note You need to log in before you can comment on or make changes to this bug.